#include <stdio.h>
#include <ctype.h>
#ifndef VOS3
#  include <sys/types.h>
#  include <sys/stat.h>
#endif
#ifdef MSDOS
#  include <fcntl.h>
#endif

#ifdef LSI_C
int	fprintf_(FILE *, const char *, ...);
#else
#  define fprintf_ fprintf
#endif

#define MEMBLEN 8
#define	ERRLVL	8

#define stdinsign(s) ((s) != NULL && *(s) == '-' && (s)[1] == '\0')

typedef	int	boolean;
boolean	rev, bs_dollar = 0, submap = 0;

extern	char	atoektbl[][0x100];

char	*com;

char	*mes[] = {
	"",
	"Illegal option",
	"Can't open input",
	"Can't open output",
	"Too many arguments",
#ifdef VOS3
	"Is a partitioned dataset",
#else
	"Is a directory",
#endif
	"Several input files couldn't be opened",
	"Sorry, can't malloc",
};

errexit(fnm, n)
char	*fnm;
int	n;
{
	fprintf_(stderr, "%s: ", com);
	fprintf_(stderr, (fnm == NULL ? "" : "%s: "), fnm);
	fprintf_(stderr, "%s.\n", mes[n]);
#ifdef VOS3
	exit(ERRLVL);
#else
	exit(n);
#endif
}

#ifdef VOS3

 /* VOS3ˤơǡå̾'#'ǻǤ롣string.hɬ */
FILE	*efopen(s, m)
char	*s, *m;
{
	char	*p, *malloc();
	FILE	*f;

	if(*s != '#') return(fopen(s, m));
	if(NULL == (p = malloc(strlen(s) + 2))) errexit((char *)NULL, 7);
	sprintf(p, "'%s'", ++s);
	f = fopen(p, m);
	free(p);
	return(f);
}
#define fopen efopen

#endif /* VOS3 */

#ifndef VOS3
#  ifndef MSDOS
isdir(fnm)
char	*fnm;
{
	struct	stat	statbuf;

	return(stat(fnm, &statbuf) == 0 &&
	       (statbuf . st_mode & S_IFMT) == S_IFDIR);
}
#  endif
#else
isdir(fnm)
char	*fnm;
{
	FILE	*f;
	extern	FILE	*popen();
	char	s[MEMBLEN + 1];
	int	retval;

	if(NULL == (f = popen(fnm, "r"))) return(0);
	retval = (NULL == nextmem(s, f) || *s != '\0');
	fclose(f);
	return(retval);
}
#endif

 /* sargv[0]ΤȤºݤΥޥ̾򼨤ʸ֤sƤѡ*/
char	*combasename(s)
char	*s;
{
#ifdef VOS3
 /* ζʸڤꡢʸѴ */
	int	i;
	char	*malloc(), *p, *q, *r;

	for(r = s, i = 0; *r && *r != ' '; r++, i++);
	if(NULL == (p = malloc(i + 1))) errexit((char *)NULL, 7);
	for(q = p, r = s; i; i--, q++, r++) *q = tolower(*r);
	*q = '\0';
	return(p);
#else
#ifdef MSDOS
 /* Ǹ'\\'':'1ļ(ʤƬ)Ϥơ'\0'ޤ'.'ФޤǤ
    ꡢΤʸѴ(λϹͤʤ)*/
	int	i;
	char	*malloc(), *p, *q, *r;

	p = NULL;
	for(r = s; *r; r++) if(*r == '\\' || *r == ':') p = r;
	if(p != NULL) s = ++p;
	for(r = s, i = 0; *r && *r != '.'; r++, i++);
	if(NULL == (p = malloc(i + 1))) errexit((char *)NULL, 7);
	for(q = p, r = s; i; i--, q++, r++) *q = tolower(*r);
				 /* Υե̾ͤ */
	*q = '\0';
	return(p);
#else
 /* Ǹ'/'(ʤƬ) */
	char	*p, *r;

	p = NULL;
	for(r = s; *r; r++) if('/' == *r) p = r;
	return(p != NULL ? ++p : s);
#endif /* MSDOS */
#endif /* VOS3 */
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c, flshp = -1; /* -1̵ 0ĥХåե󥰤 1Ĥʤ */
	boolean	inonly = 1;
	extern	int	optind, opterr;
	extern	char	*optarg;

	rev = !strcmp(combasename(*av), "ektoa"); /* 1 or 0 */

	com = *av;
	opterr = 0;

	while(EOF != (c = getopt(ac, av, "ofrsu"))){
		switch(c){
		case 'o': inonly = 0; break;
		case 'f': flshp = 1; break;
		case 'r': rev ^= 1; break;
		case 's': bs_dollar ^= 1; break;
		case 'u': submap ^= 1; break;
		default: errexit((char *)NULL, 1);
		}
	}
	if(bs_dollar){
		tblexc(0x24, 0x5c);
	}
	if(submap){
		tblexc(0x1a, 0x9e);
	}

	if(inonly && ac > optind){
		FILE	*inf;
		int	erf = 0;

		if(flshp == -1) flshp = 0; /* ɸ */
		av += optind;
		ac -= optind;

		if(flshp) setbuf(stdout, NULL);

		while(ac--){
			if(stdinsign(*av)){
#ifdef MSDOS
				fsetbin(stdin);
				fsetbin(stdout);
#endif
				atoek(stdin, stdout);
			} else
#ifndef MSDOS
			if(isdir(*av)){
				erf |= 02;
				fprintf_(stderr, "%s: %s: Is a directory.\n",
					 com, *av);
			} else
#endif
			if(NULL == (inf = fopen(*av, "r"))){
				erf |= 01;
				fprintf_(stderr, "%s: %s: Can't open input.\n",
					 com, *av);
			} else {
#ifdef MSDOS
				fsetbin(inf);
				fsetbin(stdout);
#endif
				atoek(inf, stdout);
				fclose(inf);
			}
			av++;
		}
		if(erf) errexit((char *)NULL, 6);
	} else {
		char	*infnm, *otfnm;
		FILE	*inf, *otf;

		inf = stdin;
		otf = stdout;
		infnm = otfnm = NULL;

		av += ac;
		ac -= optind;
		while(ac--){
			switch(ac){
			case 0: infnm = *--av; break;
			case 1: otfnm = *--av; break;
			default: errexit((char *)NULL, 4);
			}
		}

		if(stdinsign(infnm)) inf = stdin; else if(infnm != NULL){
#ifndef MSDOS
			if(isdir(infnm)) errexit(infnm, 5);
#endif
			if(NULL== (inf= fopen(infnm, "r"))) errexit(infnm, 2);
		}
		if(otfnm != NULL){
#ifndef MSDOS
			if(isdir(otfnm)) errexit(otfnm, 5);
#endif
			if(NULL== (otf= fopen(otfnm, "w"))) errexit(otfnm, 3);
			if(flshp == -1) flshp = 0; /* ɸϰʳ */
		} else
			if(flshp == -1) flshp = 0; /* ɸ */

		if(flshp) setbuf(otf, NULL);

#ifdef MSDOS
		fsetbin(inf);
		fsetbin(otf);
#endif
		atoek(inf, otf);
		fclose(inf);
		fclose(otf);
	}
	return(0);
}

atoek(inf, otf)
register FILE	*inf, *otf;
{
	register int	c;
	char	*tbl;

	tbl = atoektbl[rev];
	while((c = getc(inf)) != EOF){
		putc(tbl[c], otf);
	}
}

#define	touint(c) ((c) & 0xff)

tblexc(c, d)
int	c, d;
{
	char	b;

	b = atoektbl[0][c];
	atoektbl[0][c] = atoektbl[0][d];
	atoektbl[0][d] = b;

	b = atoektbl[1][touint(atoektbl[0][c])];
	atoektbl[1][touint(atoektbl[0][c])] =
		atoektbl[1][touint(atoektbl[0][d])];
	atoektbl[1][touint(atoektbl[0][d])] = b;
}
