#ifdef MSDOS
#  define DEFAULT_MSK
#endif

#include <stdio.h>
#include <ctype.h>
#ifndef VOS3
#  include <sys/types.h>
#  include <sys/stat.h>
#endif

#ifdef LSI_C
int	fprintf_(FILE *, const char *, ...);
#else
#  define fprintf_ fprintf
#endif

#ifdef DEFAULT_MSK
int	mskcode = 1;
#else
int	mskcode = 0;
#endif

#define	isMSK1(c) (0x81 <= (c) && (c) <= 0x9F || 0xE0 <= (c) && (c) <= 0xEF)
#define	isEUC1(c) (0xA1 <= (c) && (c) <= 0xFE)
#define	isEUCkana1(c) (0x8E == (c))
#define highbyte(c) (((unsigned)(c)) >> 8)

#ifdef VOS3
#  define ERRLVL 8
#  define MEMBLEN 8
#else
#  define ERRLVL 1
#endif

#define KEISESC 0x0A
#define KEISIN	0x42
#define KEISOUT 0x41

int	wungetc_buf = EOF;

#define stdinsign(s) ((s) != NULL && *(s) == '-' && (s)[1] == '\0')

cantopen(s)
char	*s;
{
	fprintf_(stderr, "Can't open %s.\n", s), exit(ERRLVL);
}

usage()
{
	fprintf_(stderr, "usage: cconv [-rnusc] [input-file [output-file]]\n");
	exit(ERRLVL);
}

#ifdef VOS3
 /* VOS3ˤơǡå̾'#'ǻǤ롣string.hɬ */
FILE	*expopen(fn, s, m)
FILE	*((*fn)());
char	*s, *m;
{
	char	*buf, *p, *malloc();
	FILE	*f;

	if(*s != '#') return((*fn)(s, m));
	if(NULL == (buf = malloc(strlen(s) + 2))){
		fprintf_(stderr, "Sorry, can't malloc.\n");
		exit(ERRLVL);
	}
	p = buf;

	++s; /* skip '#' */
	*p++ = '\'';
	while(*s && *s != '/') *p++ = *s++;
	*p++ = '\'';
	while(*p++ = *s++);

	f = (*fn)(buf, m);
	free(buf);
	return(f);
}
FILE	*orgfopen(s, m) char *s, *m; {return(fopen(s, m));}
FILE	*orgpopen(s, m) char *s, *m;
	{extern FILE *popen(); return(popen(s, m));}
#define fopen(s, m) expopen(orgfopen, s, m)
#define popen(s, m) expopen(orgpopen, s, m)

#endif /* VOS3 */

#ifndef VOS3
#  ifndef MSDOS
isdir(fnm)
char	*fnm;
{
	struct	stat	statbuf;

	return(stat(fnm, &statbuf) == 0 &&
	       (statbuf . st_mode & S_IFMT) == S_IFDIR);
}
#  endif
#else
isdir(fnm)
char	*fnm;
{
	FILE	*f;
	char	s[MEMBLEN + 1];
	int	retval;

	if(NULL == (f = popen(fnm, "r"))) return(0);
	retval = (NULL == nextmem(s, f) || *s != '\0');
	fclose(f);
	return(retval);
}
#endif

FILE	*fopen_chk(fnm, mode)
char	*fnm, *mode;
{
	FILE	*f;

#ifndef MSDOS
	if(isdir(fnm)){
		fprintf_(stderr, "%s: Is a directory.\n", fnm);
		exit(ERRLVL);
	}
#endif
	if(NULL == (f = fopen(fnm, mode))) cantopen(fnm);
	return(f);
}

#ifdef VOS3
int	wgetc(inf)
register FILE	*inf;
 /* ⡼ɤwungetc_bufեǤϤʤ1ĤäƤʤΤǡʣ
    ե뤫¹wgetcϤǤʤ */
{
	register int	c;
	static	int	kmode = 0;
	static	int	pos = 0, tabrest = 0;

	if(wungetc_buf != EOF){
		c = wungetc_buf;
		wungetc_buf = EOF;
		return(c);
	} /* wungetcᤷʸκwgetcǤϡposưʤ */

	if(tabrest) return(--tabrest, ' ');

	for(;;){
		c = getc(inf);
		if(c != KEISESC) break;
		c = getc(inf);
		if(c == KEISIN){
			kmode = 1;
		} else { /* KEISOUTΥåϤʤļȴ */
			kmode = 0;
		}
	}
	if(c == EOF){ /* ǰΰ */
		kmode = 0;
		return(c);
	}
	if(c == '\n'){
		kmode = 0;
		if(!pos){
			ungetc(c, inf);
			return(++pos, ' ');
		} else {
			return(pos = 0, c);
		}
	}
	if(c == ' ' || c == '\f'){
		++pos;
		return(' ');
	}
	if(kmode){
		pos += 2;
		return((c << 8) | (0xFF & getc(inf)));
	}
	if(c == '\t'){ /* TAB򸫤Τkmode0λΤ */
		tabrest = 8 - (pos & 7);
		pos += tabrest;
		return(--tabrest, ' ');
	}
	/* else */{
		++pos;
		return(c);
	}
}

int	wputc(c, otf)
register int	c;
register FILE	*otf;
 /* ⡼ɤեǤϤʤ1ĤäƤʤΤǡʣեؤ
    ¹wputcϤǤʤ */
{
	static	int	kmode = 0;

	if(c == EOF) return(c); /* ǰΰ */
	if(c == ' '){
		putc(c, otf);
	} else
	if(highbyte(c)){
		if(!kmode){
			kmode = 1;
			putc(KEISESC, otf);
			putc(KEISIN, otf);
		}
		putc(highbyte(c), otf);
		putc(c & 0xFF, otf);
	} else
	if(c == '\n'){
		kmode = 0;
		putc(c, otf);
	} else {
		if(kmode){
			kmode = 0;
			putc(KEISESC, otf);
			putc(KEISOUT, otf);
		}
		putc(c, otf);
	} /* եäνϹͤɤ*/
	return(c);
}

#else /* !VOS3 */
wgetc(f)
register FILE	*f;
 /* 2Хgetc롼detabԤâְ֤ϰĤʤ
    ΤǡʣΥե뤫wgetc褦ʻȤϤǤʤ*/
{
	register int	c;
	static	int	pos = 0, tabrest = 0;

	if(wungetc_buf != EOF){
		c = wungetc_buf;
		wungetc_buf = EOF;
		return(c);
	} /* wungetcᤷʸκwgetcǤϡposưʤ */

	if(tabrest) return(--tabrest, ' ');

	c = getc(f);
	if(c == '\n'){
		if(!pos){
			ungetc(c, f);
			return(++pos, ' ');
		} else {
			return(pos = 0, c);
		}
	}
	if(c == '\t'){
		tabrest = 8 - (pos & 7);
		pos += tabrest;
		return(--tabrest, ' ');
	}
	if(c == '\f') c = ' '; /*  */
	if(isascii(c)) return(++pos, c);
	if(mskcode){
		if(isMSK1(c)) return(pos += 2, (c << 8) | getc(f));
		return(++pos, c);
	} else {
		if(isEUC1(c)) return(pos += 2, (c << 8) | getc(f));
		if(isEUCkana1(c)) return(++pos, (c << 8) | getc(f));
		return(++pos, c);
	}
}

#define	wputc(c, f)				\
{						\
	if(highbyte(c)) putc(highbyte(c), (f));	\
	putc(0xFF & (c), (f));			\
}

#endif /* !VOS3 */

#define wungetc(c) (wungetc_buf = (c))
 /* ungetХåեϰĤʤΤǡʣΥե뤫wungetcϤǤʤ*/

main(ac, av)
int	ac;
char	*av[];
{
	int	c;
	int	bs_org = '\\', bs_new = '$', modeflg = 0;
#define FLG_NONJ      01
#define FLG_STRIPCMNT 02

	extern	int	optind;
	extern	char	*optarg;

	while(EOF != (c = getopt(ac, av, "rnusc"))){
		switch(c){
		case 'r':
			bs_org = '$';
			bs_new = '\\';
			break;
#ifndef VOS3
		case 'n':
			modeflg |= FLG_NONJ;
			 /* through */
		case 's':
			mskcode = 1; break;
		case 'u':
			mskcode = 0; break;
#else
		case 'n': case 's': case 'u':
			fprintf_(stderr,
				 "%c: Meaningless option, ignored.\n", c);
			break;
#endif
		case 'c':
			modeflg |= FLG_STRIPCMNT; break;
		default: usage();
		}
	}

	av += optind;
	ac -= optind;
	if(ac > 2) usage();

	cconv(ac > 0 && !stdinsign(av[0]) ? fopen_chk(av[0], "r") : stdin,
	      ac > 1			  ? fopen_chk(av[1], "w") : stdout,
	      bs_org, bs_new, modeflg);
	return(0);
}

 /* ѴΥᥤ롼 */
cconv(inf, otf, bs_org, bs_new, modeflg)
register FILE	*inf, *otf;
int	bs_org, bs_new, modeflg;
{
	register int	c;

	while(EOF != (c = wgetc(inf))){
		switch(c){
		case '/':
			if('*' == (c = wgetc(inf))){ /* ν */
				pass_comment(inf, otf,
						modeflg & FLG_STRIPCMNT);
			} else {
				wungetc(c);
				wputc('/', otf);
			}
			break;
#define pass_char(i, o, b, c, flg) \
	pass_quote(i, o, b, c, '\'', flg & FLG_NONJ)
#define pass_string(i, o, b, c, flg) \
	pass_quote(i, o, b, c, '\"', flg & FLG_NONJ)
		case '\'': /* ' 'ν */
			wputc(c, otf);
			pass_char(inf, otf, bs_org, bs_new, modeflg);
			break;
		case '\"': /* " "ν */
			wputc(c, otf);
			pass_string(inf, otf, bs_org, bs_new, modeflg);
			break;
		default:
			if(c == bs_org){
				if('\n' == (c = wgetc(inf))){
					 /* \ԡפν */
					wputc(bs_new, otf);
					wputc('\n', otf);
				} else {
					wungetc(c);
					wputc(bs_org, otf);
				}
			} else {
				wputc(c, otf);
				break;
			}
		}
	}
}

 /* ʸɽνΡ'ס뤤ʸɽνΡ"פޤǤ
    quote_charˡ'ס"פΤ줫äƤ */
pass_quote(inf, otf, bs_org, bs_new, quote_char, nonj)
register FILE	*inf, *otf;
int	bs_org, bs_new,	quote_char;
int	nonj; /* modeflg & FLG_NONJ, non0 if non_Japanese mode */
{
	register int	c;

	while(EOF != (c = wgetc(inf))){
		if(c == quote_char){ /* ʸ()ɽν򸡽 λ */
			wputc(c, otf);
			return;
		} else
		if(c == bs_org){ /* ʸ()Ρ\פν */
			if((c = wgetc(inf)) == bs_org){
				wputc(bs_org, otf);
			} else {
				wputc(bs_new, otf);
				wputc(c, otf);
				if(nonj) wescape(c, inf, otf, bs_org, bs_new);
			}
		 /* \\פϡ\פˡʳΡ\ʸפϡ$ʸפ
		     ѹν \x??, \???, \ ˤбǽ */
		} else
		if(c == bs_new){ /* ʸ()Ρ$פ$$פ */
			wputc(bs_new, otf);
			wputc(bs_new, otf);
			continue;
		} else
		/* default */{
			wputc(c, otf);
			if(nonj) wescape(c, inf, otf, bs_org, bs_new);
			continue;
		}
	}
}

 /* ܸ첽ѥбΥФѴˡ2Хܤ\פ
    Ф */
wescape(c, inf, otf, bs_org, bs_new)
register int	c;
register FILE	*inf, *otf;
int	bs_org, bs_new;
{
	c &= 0xFF;
	if(c == bs_org){
		c = wgetc(inf);
		if(c != bs_org){
			wungetc(c);
		}
	} else
	if(c == bs_new){
		wputc(c, otf);
	}
}

 /* νޤǤ̵Ѵǽ */
pass_comment(inf, otf, stripc)
register FILE	*inf, *otf;
int	stripc; /* modeflg & FLG_STRIPCMNT, non0 if comment_strip mode */
{
 /* Ƚ⡼ɤξ硢ȳϰ֤ȳƲԤμ˶
    Ȥ1Ĥζ֤뤳ȤȡȽ⡼ɤǤ
    Ԥ˶뤳ȤݾڤΤ */
	register int	c;

	if(!stripc){
		wputc('/', otf);
		wputc('*', otf);
	} else {
		wputc(' ', otf);
	}
	while(EOF != (c = wgetc(inf))){
		switch(c){
		case '*':
			if('/' == (c = wgetc(inf))){ /* ν򸡽 */
				if(!stripc){
					wputc('*', otf);
					wputc('/', otf);
				}
				return;
			} else {
				wungetc(c);
				if(!stripc) wputc('*', otf);
			}
			break;
		case '\n':
			wputc(c, otf); /* even if stripc!=0 */
			if(stripc) wputc(' ', otf);
			break;
		default:
			if(!stripc) wputc(c, otf);
			break;
		}
	}
}
