#include <stdio.h>
#include <ctype.h>
#ifndef VOS3
#  include <sys/types.h>
#  include <sys/stat.h>
#endif
#ifdef MSDOS
#  include <fcntl.h>
#endif

#ifdef LSI_C
int	fprintf_(FILE *, const char *, ...);
#else
#  define fprintf_ fprintf
#endif

#ifdef VOS3
#  define isascii(c) 1
#endif
#ifdef LSI_C
#  define is_xdigit(x) isxdigit(x)
#  define is_digit(c) isdigit(c)
#  define is_upper(c) isupper(c)
#else
#  define is_xdigit(x) (isascii(x) && isxdigit(x))
#  define is_digit(c) (isascii(c) && isdigit(c))
#  define is_upper(c) (isascii(c) && isupper(c))
#endif

#ifndef LSI_C
#  define fsetbin(fp) setmode(fileno(fp), O_BINARY)
#endif

#define MEMBLEN 8
#define	ERRLVL	8

typedef	int	boolean;
boolean	bs_dollar = 0;

#define	SS2	0x8E
#define is_ujis(c) (0xA1 <= (c) && (c) <= 0xFE)
#define is_ukata(c) (0xA1 <= (c) && (c) <= 0xFE) /* 0xFE should be 0xDF? */
#define isukata(c) /* char c; */ is_ukata((int)(unsigned char)(c))
#define GETA	"\242\256"

#define stdinsign(s) ((s) != NULL && *(s) == '-' && (s)[1] == '\0')

char	*com;

#define ATOEBTBL atoektbl
extern	char	ATOEBTBL[][0x100];

char	*mes[] = {
	"",
	"Illegal option.",
	"Can't open input.",
	"Can't open or write to output.",
	"Too many arguments.",
#ifdef VOS3
	"Is a partitioned dataset.",
#else
	"Is a directory.",
#endif
	"Several input files couldn't be opened.",
	"Sorry, can't malloc.",
	"Can't switch to binary mode.", /* VOS3 */
};

errexit(fnm, n)
char	*fnm;
int	n;
{
	fprintf_(stderr, "%s: ", com);
	fprintf_(stderr, (fnm == NULL ? "" : "%s: "), fnm);
	fprintf_(stderr, "%s\n", mes[n]);
#ifdef VOS3
	exit(ERRLVL);
#else
	exit(n);
#endif
}

#define	warn()								\
{									\
	fprintf_(stderr, "%s: WARNING: Illegal KANJI-IN or ", com);	\
	fprintf_(stderr, "KANJI-OUT sequence found in input file.\n");	\
}

#define cantmalloc() errexit((char *)NULL, 7)
#define cantbinopen() errexit((char *)NULL, 8)

#ifdef VOS3

 /* VOS3ˤơǡå̾'#'ǻǤ롣string.hɬ */
FILE	*expopen(fn, s, m)
FILE	*((*fn)());
char	*s, *m;
{
	char	*buf, *p, *malloc();
	FILE	*f;

	if(*s != '#') return((*fn)(s, m));
	if(NULL == (buf = malloc(strlen(s) + 2))) errexit((char *)NULL, 7);
	p = buf;

	++s; /* skip '#' */
	*p++ = '\'';
	while(*s && *s != '/') *p++ = *s++;
	*p++ = '\'';
	while(*p++ = *s++);

	f = (*fn)(buf, m);
	free(buf);
	return(f);
}
FILE	*orgfopen(s, m) char *s, *m; {return(fopen(s, m));}
FILE	*orgpopen(s, m) char *s, *m;
	{extern FILE *popen(); return(popen(s, m));}
#define fopen(s, m) expopen(orgfopen, s, m)
#define popen(s, m) expopen(orgpopen, s, m)

FILE	*binreopen(orgf, mode)
FILE	*orgf;
char	mode;
{
	static	char	opt[ ] = "?,BINARY";

	if(isterm(orgf)) return(orgf);
	*opt = mode;
	if((orgf= freopen(NULL, opt, orgf)) == NULL) errexit((char *)NULL, 8);
	return(orgf);
}

#endif /* VOS3 */

#ifndef VOS3
#  ifndef MSDOS
isdir(fnm)
char	*fnm;
{
	struct	stat	statbuf;

	return(stat(fnm, &statbuf) == 0 &&
	       (statbuf . st_mode & S_IFMT) == S_IFDIR);
}
#  endif
#else
isdir(fnm)
char	*fnm;
{
	FILE	*f;
	char	s[MEMBLEN + 1];
	int	retval;

	if(NULL == (f = popen(fnm, "r"))) return(0);
	retval = (NULL == nextmem(s, f) || *s != '\0');
	fclose(f);
	return(retval);
}
#endif

#ifndef VOS3
#  define ctoi(c) ((c)- (is_digit(c) ? '0' : (is_upper(c) ? 'A'-10 : 'a'-10)))
#else
extern	unsigned char	cvalue[];
#  define ctoi(c) ((int)cvalue[c]) /* cvalue[] is extern */
#endif

main(ac, av)
int	ac;
char	*av[];
{
	int	c, flshp = -1; /* -1̵ 0ĥХåե󥰤 1Ĥʤ */
	boolean	inonly = 1, notbin = 0;
	extern	int	optind, opterr;
	extern	char	*optarg;

	com = *av;
	opterr = 0;

	while(EOF != (c = getopt(ac, av, "ofts"))){
		switch(c){
		case 'o': inonly = 0; break;
		case 'f': flshp = 1; break;
		case 't': notbin = 1; break;
		case 's': bs_dollar ^= 1; break;
		default: errexit((char *)NULL, 1);
		}
	}
	if(bs_dollar){
		tblexc(0x24, 0x5c);
	}

	if(inonly && ac > optind){
		FILE	*inf;
		int	erf = 0;

		if(flshp == -1) flshp = 0; /* ɸ */
		av += optind;
		ac -= optind;

		if(flshp) setbuf(stdout, NULL);

		while(ac--){
			if(stdinsign(*av)){
#ifdef VOS3
				if(!notbin) binreopen(stdout, 'w');
		 /* If not partitioned, 'a' is preferrable, but we can't
		    examine whether stdout is partitioned or not... (sigh) */
#endif
#ifdef MSDOS
				fsetbin(stdin);
#endif
				ektou(stdin, stdout);
			} else
#ifndef MSDOS
			if(isdir(*av)){
				erf |= 02;
				fprintf_(stderr, "%s: %s: Is a directory.\n",
					 com, *av);
			} else
#endif
			if(NULL == (inf = fopen(*av, "r"))){
				erf |= 01;
				fprintf_(stderr, "%s: %s: Can't open input.\n",
					 com, *av);
			} else {
#ifdef VOS3
				if(!notbin) binreopen(stdout, 'w');
#endif
#ifdef MSDOS
				fsetbin(inf);
#endif
				ektou(inf, stdout);
				fclose(inf);
			}
			av++;
		}
		if(erf) errexit((char *)NULL, 6);
	} else {
		char	*infnm, *otfnm;
		FILE	*inf, *otf;

		inf = stdin;
		otf = stdout;
		infnm = otfnm = NULL;

		av += ac;
		ac -= optind;
		while(ac--){
			switch(ac){
			case 0: infnm = *--av; break;
			case 1: otfnm = *--av; break;
			default: errexit((char *)NULL, 4);
			}
		}

		if(stdinsign(infnm)) inf = stdin; else if(infnm != NULL){
#ifndef MSDOS
			if(isdir(infnm)) errexit(infnm, 5);
#endif
			if(NULL == (inf = fopen(infnm, "r")))
				errexit(infnm, 2);
		}
		if(otfnm != NULL){
#ifndef MSDOS
			if(isdir(otfnm)) errexit(otfnm, 5);
#endif
			if(NULL== (otf= fopen(otfnm, "w"))) errexit(otfnm, 3);
			if(flshp == -1) flshp = 0; /* ɸϰʳ */
		} else
			if(flshp == -1) flshp = 0; /* ɸ */

		if(flshp) setbuf(otf, NULL);

#ifdef VOS3
		if(!notbin) binreopen(otf, 'w');
#endif
#ifdef MSDOS
		fsetbin(inf);
#endif
		ektou(inf, otf);
		fclose(inf);
		fclose(otf);
	}
	return(0);
}

#define KEISESC 0x0a
#define KEISIN2 0x42
#define KEISOT2 0x41
#define EB_SPC	0x40
#define EB_CR	0x15

#define isnotspcl(c) \
	((c) != EOF && (c) != EB_SPC && (c) != EB_CR && (c) != KEISESC)

#define eputc(c, f) \
	if(EOF == putc((c), (f))) errexit((char *)NULL, 2)
#define ewputc(c, d, f) \
	if(is_ujis(c) && is_ujis(d)){ putc(c, f); eputc(d, f); } \
	else if(EOF == fputs(GETA, f)) errexit((char *)NULL, 2)

ektou(inf, otf)
register FILE	*inf, *otf;
{
	register int	c, d;
	int	mode = 0; /* mode 0=EBCDIK 1=KEIS */
	register char	*tbl = ATOEBTBL[1];

	while((c = getc(inf)) != EOF){
		if(c == EB_SPC){
			eputc(tbl[c], otf);
		} else if(c == EB_CR){
			eputc(tbl[c], otf);
			mode = 0;
		} else if(c == KEISESC){
			switch(getc(inf)){
			case KEISIN2: mode = 1; break;
			case KEISOT2: mode = 0; break;
			default: /* warn() */; /* ignore it */
			}
		} else {
			switch(mode){
			case 1:
				d = getc(inf);
				ewputc(c, d, otf);
				 /* d==EOF isn't checked */

				while((c = getc(inf)), isnotspcl(c)){
					d = getc(inf);
					ewputc(c, d, otf);
					 /* d==EOF isn't checked */
				}
				if(c == EOF) return; else ungetc(c, inf);
				break;

			default:
				c = tbl[c];
				if(isukata(c)) putc(SS2, otf);
				eputc(c, otf);

				while((c = getc(inf)), isnotspcl(c)){
					c = tbl[c];
					if(isukata(c)) putc(SS2, otf);
					eputc(c, otf);
				}
				if(c == EOF) return; else ungetc(c, inf);
			}
		}
	}
	/* ˤʤˤդäݤϡEOFreturnľ */
}

/*
atoh(s)
char	*s;
{
	int	c = 0;

	for(; is_xdigit(*s); s++){
		c <<= 4;
		c += ctoi(*s);
	}
	return(c);
}
*/

#define	touint(c) ((c) & 0xff)

tblexc(c, d)
int	c, d;
{
	char	b;

	b = ATOEBTBL[0][c];
	ATOEBTBL[0][c] = ATOEBTBL[0][d];
	ATOEBTBL[0][d] = b;

	b = ATOEBTBL[1][touint(ATOEBTBL[0][c])];
	ATOEBTBL[1][touint(ATOEBTBL[0][c])] =
		ATOEBTBL[1][touint(ATOEBTBL[0][d])];
	ATOEBTBL[1][touint(ATOEBTBL[0][d])] = b;
}
