/*LINTLIBRARY*/

/***********************************************************************
		getopt.c (This is in the public domain)
***********************************************************************/

#include <stdio.h>

#ifdef LSI_C
int	fprintf_(FILE *, const char *, ...);
#else
#  define fprintf_ fprintf
#endif

#define ERR(as, ac)						  \
	if(opterr){						  \
		fprintf_(stderr, "%s%s%c\n", argv[0], as, ac);	  \
	}

#ifndef MSDOS
#ifndef SYSVR2
#ifndef VOS3
#define strchr	index
#endif
#endif
#endif
 /* MSC 4.0 doesn't know disjunctive #if's.  */

extern	int	strcmp();
extern	char	*strchr();

int	opterr = 1;
int	optind = 1;
int	optopt;
char	*optarg;

int	getopt(argc, argv, opts)
int	argc;
char	**argv, *opts;
{
	static	int	sp = 1;
	register int	c;
	register char	*cp;

	if(sp == 1){
		if(optind >= argc ||
		   argv[optind][0] != '-' || argv[optind][1] == '\0'){
			return(EOF);
		} else if(!strcmp(argv[optind], "--")){
			optind++;
			return(EOF);
		}
	}
	optopt = c = argv[optind][sp];

	if(c == ':' || (cp = strchr(opts, c)) == NULL){
		ERR(": unknown option, -", c);
		if(argv[optind][++sp] == '\0'){
			optind++;
			sp = 1;
		}
		return('?');
	}
	if(*++cp == ':'){
		if(argv[optind][sp+1] != '\0'){
			optarg = &argv[optind++][sp + 1];
		} else if(++optind >= argc){
			ERR(": argument missing for -", c);
			sp = 1;
			return('?');
		} else {
			optarg = argv[optind++];
		}
		sp = 1;
	} else {
		if(argv[optind][++sp] == '\0'){
			sp = 1;
			optind++;
		}
		optarg = NULL;
	}
	return(c);
}
