/*
		public domain uudecode.c
*/

#include <stdio.h>
#ifndef VOS3
#  include <string.h>
#  ifdef MSDOS
#    include <ctype.h>
#  else
#    include <pwd.h> /* for getpwnam */
#  endif
#  include <fcntl.h>
#  include <errno.h>
#endif

#ifdef TOOLS
     /* UNIX-like tools1ĤȤƥѥ롦ۤϤdefine
	̥ѥå(ektou)ǥѥ롦ۤdefineʤ
	MSDOSξϾtools.hincludeפȤƤϤʤ */
#  include "tools.h"
#else
#  define cswitch switch
#  define s_conv_to_unix_format(s) (s)
#  ifndef MSDOS
#    define fsetbin(f) 0
#  endif
typedef	unsigned char	bool;
#endif

#define	errout(s) fputs((s), stderr)
#define	errcout(c) fputc((c), stderr)

#ifdef VOS3
#  define ERRLVL 8
#else
#  define ERRLVL 1
#endif

char	*cmdname = "uudecode";

static	bool	textmode = 0, bs_dollar = 0, ign_garbage = 0, noclobber = 0;
static	bool	b64_mode = 0, xx_mode = 0, fnm_until_eol = 0, multi_dec = 0;
static	bool	pathstrip = 0;
static	char	*tofile = NULL, STDIOMARK[] = "-";

#define isSTDIO(s) (!strcmp((s), STDIOMARK))
 /* VOS3Ǥ-pץξʤɤstdout򰷤ɬפ */

#define LBUFSIZ 256

#ifdef VOS3
 /* VOS3ˤơǡå̾'#'ǻǤ롣string.hɬ */
static	FILE	*expopen(fn, s, m)
FILE	*((*fn)());
char	*s, *m;
{
	char	*buf, *p, *malloc();
	FILE	*f;

	if(*s != '#') return((*fn)(s, m));
	if(NULL == (buf = malloc(strlen(s) + 2))){
		fprintf(stderr, "Sorry, can't malloc.\n");
		exit(ERRLVL);
	}
	p = buf;

	++s; /* skip '#' */
	*p++ = '\'';
	while(*s && *s != '/') *p++ = *s++;
	*p++ = '\'';
	while(*p++ = *s++);

	f = (*fn)(buf, m);
	free(buf);
	return(f);
}
static	FILE	*orgfopen(s, m) char *s, *m; {return(fopen(s, m));}
static	FILE	*orgpopen(s, m) char *s, *m;
	{extern FILE *popen(); return(popen(s, m));}
#define fopen(s, m) expopen(orgfopen, s, m)
#define popen(s, m) expopen(orgpopen, s, m)

static	FILE	*binreopen(orgf, mode)
FILE	*orgf;
char	mode;
{
	static	char	opt[ ] = "?,BINARY";

	if(isterm(orgf)) return(orgf);
	*opt = mode;
	if((orgf = freopen(NULL, opt, orgf)) == NULL){
		fprintf(stderr, "Can't switch to binary mode.\n");
		exit(ERRLVL);
	}
	return(orgf);
}
#endif /* VOS3 */

static	void	decode(), fnameexp();

static	void	usage()
{
	errout("Usage: "), errout(cmdname);
	errout(" [-tspigxlcb] [-o outfile] [infile]\n");
	exit(ERRLVL);
}

static	void	cmd_errout(s)
char	*s;
{
	fputs(cmdname, stderr), fputs(": ", stderr), fputs(s, stderr);
}

#define strconstlen(s) (sizeof(s) - 1)
#define strconsthead(h, s) (!strncmp((h), (s), strconstlen(h)))

static	void	err_cantopen(fnm)
char	*fnm;
{
	cmd_errout("Can't open ");
	errout(s_conv_to_unix_format(fnm));
	errcout('\n');
	exit(ERRLVL);
}

main(ac, av)
int	ac;
char	**av;
{
	int	c, fmode;
	char	buf[LBUFSIZ], fnmbuf[LBUFSIZ], kindbuf[LBUFSIZ];
	extern	int	optind, opterr;
	extern	char	*optarg;
	register FILE	*inf, *otf;
	bool	first_otf;

#ifdef TOOLS
#  ifdef EXPLICIT_EXPARG /* for tools */
	ac = expand_arg(av[0], get_psp_arg(), &av);
#  endif
#  ifndef MSDOS
	setcmdname(av[0]);
#  endif
	opterr = 0;
#endif

	while(EOF != (c	= getopt(ac, av, "tspo:igmxlcb"))){
		cswitch(c){
		case 't': textmode = 1; break;
		case 'p': tofile = STDIOMARK; break;
		case 'o': tofile = optarg; break;
		case 's': bs_dollar ^= 1; break;
		case 'g': ign_garbage = 1; break;
		case 'i': noclobber = 1; break;
		case 'm': /* obsolete */ /* FALLTHROUGH */
		case 'x': xx_mode = 1; break;
		case 'l': fnm_until_eol = 1; break;
		case 'c': multi_dec = 1; break;
		case 'b': pathstrip ^= 1; break;
		default: usage();
		}
	}

	av += optind;
	ac -= optind;

#ifdef VOS3
	if(pathstrip){
		fprintf(stderr, "option -b ignored on VOS3.\n");
		pathstrip = 0;
	}
	if(noclobber){
		fprintf(stderr, "option -i ignored on VOS3.\n");
		noclobber = 0;
	}
#endif
	
	switch(ac){
	case 1:
		if(!isSTDIO(*av)){
			if(NULL == (inf = fopen(*av, "r"))) err_cantopen(*av);
			break;
		} /* else FALLTHROUGH */
	case 0:
		inf = stdin;
		break;
	default:
		usage();
	}

	for(first_otf = 1; ; first_otf = 0){
		char	*otfnm;
		bool	no_stdout;

		for(;;){
			if(NULL == fgets(buf, LBUFSIZ, inf)){
				if(!first_otf) return 0;
				cmd_errout("No (or illegal) begin line\n");
				exit(ERRLVL);
			}

			if(sscanf(buf, fnm_until_eol ?
					"begi%s %o %[^\n]" : "begi%s %o %s",
				kindbuf, &fmode, fnmbuf) != 3) continue;
			 /* bufΥLBUFSIZkindbuffnmbuf
			    ȤϤʤ fnm_until_eolκDOSǤ\rϸʤ
			    (ƥȥ⡼ɤǥץ󤷤Ƥ뤫) */
			if(!strcmp(kindbuf, "n")){
				b64_mode = 0;
				break;
			} else
			if(!strcmp(kindbuf, "n-base64")){
				b64_mode = 1;
				break;
			} else continue;
		} /* beginإå򸫤Ĥ */

		no_stdout = 0;
		if(tofile != NULL){
			 /* tofileŪͿfnameexp()ѥ̾
			    strip⤷ʤ */
			otfnm = tofile;
		} else {
			fnameexp(buf, fnmbuf);
#ifndef VOS3
			if(pathstrip){
# define illname(fnm) do { \
	cmd_errout(s_conv_to_unix_format(fnm)); \
	errout(": Illegal filename\n"); \
	exit(ERRLVL); \
} while(0)
# if defined(TOOLS) && defined(MSDOS)
				if(*last_pathsep(buf, &otfnm) || !*otfnm)
					illname(buf);
# else
#  ifdef MSDOS
#   define iskanji_(c) (0x81 <= (c) && \
		((c) <= 0x9f || 0xe0 <= (c) && (c) <= 0xfc))
#   define iskanji(c) (iskanji_((unsigned char)(c)))
				char	*p;

				p = buf, otfnm = NULL;
				if(isascii(*p) && isalpha(*p) && p[1] == ':')
					otfnm = ++p, ++p;
				for(; *p; p++){
					if(*p == '/' || *p == '\\')
						otfnm = p;
					else if(iskanji(*p) && p[1])
						++p;
				}
#  else
				otfnm = strrchr(buf, '/');
#  endif
				if(NULL != otfnm){
					if(!*++otfnm) illname(buf);
				} else {
					otfnm = buf;
				}
# endif /* !TOOLS */
				if(otfnm != buf) no_stdout = 1;
				 /* strip̤"-"ǤstdoutϤʤ */
			} else
#endif /* !VOS3 */
				otfnm = buf;
		}

		if(!no_stdout && isSTDIO(otfnm)){
			static	bool	stdout_already_binmode = 0;

			if(!stdout_already_binmode && !textmode){
#ifndef VOS3
				fsetbin(stdout);
#else
				binreopen(stdout, 'w');
				 /* If stdout is not partitioned, 'a' is
				    preferrable, but we can't examine whether
				    stdout is partitioned or not... (sigh) */
#endif
				stdout_already_binmode = 1;
			}
			otf = stdout;
		} else {
#ifndef VOS3
			int	fd;
#endif

			if(!first_otf && tofile != NULL){
				/* no-op; tofileꤷ2ܰʹߤ
				   openotf򤽤Τޤ޻Ȥ */
			} else
#ifndef VOS3
			if(0 > (fd = open(otfnm, noclobber ?
			    O_WRONLY|O_CREAT|O_EXCL : O_WRONLY|O_CREAT|O_TRUNC,
			    fmode & 0777))){
				if(errno != EEXIST) err_cantopen(otfnm);

				cmd_errout(s_conv_to_unix_format(otfnm));
				errout(": Not overwritten\n");
				otf = NULL;
			} else {
				if(NULL == (otf = fdopen(fd, "w")))
					err_cantopen(otfnm);
				if(!textmode) fsetbin(otf);
			}
#else
			{
				if(NULL == (otf = fopen(otfnm, "w")))
					err_cantopen(otfnm);
				if(!textmode) binreopen(otf, 'w');
			}
#endif
		}

		decode(inf, otf); /* otfNULLʤϤԤʤ */
		if(otf != NULL && otf != stdout && tofile == NULL) fclose(otf);
		 /* otfNULL, stdouttofileξcloseʤ */

		if(!multi_dec) return 0;
	}
}

 /* ե̾'~'ǻϤޤäƤ硢Ÿ
    orgΥtmpbufʲΤ*/
static	void	fnameexp(dest, org)
char	*dest, *org;
{
	char	tmpbuf[LBUFSIZ];
#if !defined(MSDOS) && !defined(VOS3)
	struct	passwd	*pw, *getpwnam();
#endif

	if(*org != '~'){
		strcpy(dest, org);
		return;
	}

	if(sscanf(org, fnm_until_eol ? "~%[^/]/%[^\n]" : "~%[^/]/%s",
							dest, tmpbuf) != 2){
		cmd_errout("Illegal ~user\n");
		exit(ERRLVL);
	} /* orgΥLBUFSIZdesttmpbufդ뤳ȤϤʤ */
#if !defined(MSDOS) && !defined(VOS3)
	if(NULL == (pw = getpwnam(dest))){
		cmd_errout("No such user as \""), errout(dest), errout("\"\n");
		exit(ERRLVL);
	}
	strcpy(dest, pw -> pw_dir), strcat(dest, "/"), strcat(dest, tmpbuf);
#else /* MSDOS, VOS3 */
	strcpy(dest, tmpbuf);
#endif
}

#define B64EQConverted 0x61

static	void	predecode(p)
char	*p;
{
	int	c;
	char	*q;
#ifdef VOS3
	extern	char    atoektbl[][0x100];

	for(q = p; *q; q++) *q = atoektbl[1][*q & 0xff];
	 /* ASCIIˤʤ */
#endif
	if(b64_mode){
		for(q = p; c = *q; q++){
		 /* ASCIIAZaz09+/0x200x5f ('-''/'
		    Ʊ) '='򤽤ϰϳ0x61 ¾ASCIIĻʸ
		    0x7e ʳϤΤޤ */
			if(0x41 <= c && c <= 0x5a) c += 0x20 - 0x41; else
			if(0x61 <= c && c <= 0x7a) c += 0x3a - 0x61; else
			if(0x30 <= c && c <= 0x39) c += 0x54 - 0x30; else
			if(c == 0x2b)		   c =  0x5e; else
			if(c == 0x2d || c == 0x2f) c =  0x5f; else
			if(c == 0x3d)/*ASCII '='*/ c =  B64EQConverted; else
			if(0x20 <= c && c <= 0x7e) c =  0x7e;

			*q = c;
		}
	} else
	if(xx_mode){
		for(q = p; c = *q; q++){
		 /* ASCII+-09AZaz0x200x5f ('/''-'
		    Ʊ) ¾ASCIIĻʸ0x7e ʳϤΤޤ */
			if(c == 0x2b)		   c =  0x20; else
			if(c == 0x2d || c == 0x2f) c =  0x21; else
			if(0x30 <= c && c <= 0x39) c += 0x22 - 0x30; else
			if(0x41 <= c && c <= 0x5a) c += 0x2c - 0x41; else
			if(0x61 <= c && c <= 0x7a) c += 0x46 - 0x61; else
			if(0x20 <= c && c <= 0x7e) c =  0x7e;

			*q = c;
		}
	} else
	if(bs_dollar){
		for(q = p; *q; q++){
			cswitch(*q){
			case 0x24: *q = 0x5c; break;
			case 0x5c: *q = 0x24; break;
			}
		}
	}
}

#define getbin(p) /* pưΤ */ \
	(*(p) && *(p) != '\n' ? (*(p)++ - 0x20) & 0x3f : 0)

 /* ǥɤ̤ΥХĹ֤VOS3ǤASCIIѤ
    otfNULLȽϤϤʤ֤ͤƱ */
static	int	decodeline(p, otf)
char	*p;
FILE	*otf;
{
	int	n, i, j;
	register char	cbuf, c1;

	if(0 == (n = getbin(p))) return 0; /* getbin()pư */
	if(otf != NULL) for(i = 0; i < n; i++){
		if(0 == (j = (i % 3) * 2)) c1 = getbin(p);
		cbuf = c1 << (j + 2);
		c1 = getbin(p);
		cbuf |= c1 >> (4 - j);
		putc(cbuf, otf);
	}
	/* *p0ˤʤä餽ʾݥ󥿤ʤ᤺ʸƶ
	   뤫Τ褦˰ˤäơ`פǤʤʸȤ
	   켰ʥ󥳡encode̤Ρ˸ζȤ줿
	   ΤˤбǤ */
	/* Ф줿ĹnǡԤĹƤ;ʬ̵롣uuencode-v
	   ץнΤ */
	return n;
}
static	void	bdecodeline(p, otf) /* ͤä֤ʤ */
char	*p;
FILE	*otf;
{
	int	n;
	unsigned char	c1, cbuf = 0;

	if(otf == NULL) return;
	for(n = 0; *p; p++, n += 2, n %= 8){
		if((c1 = (unsigned char)*p - 0x20) > 0x40) continue;

		if(n) putc(cbuf | (c1 >> (6 - n)), otf);
		cbuf = c1 << (n + 2);
	}
}

#define iseol(c) (!(c) || (c) == 0x0a || (c) == 0x0d)
 /* ASCIIǤӤʤΤ'\n'ȤϤʤ0x0d򺮤ΤǰΤ */
#define ENCSIZ 45

static	int	gbgchk(p)
 /* -iץΥߤɤȽѡencodedǤʤʤ-1encoded
    Ǹ(encoded줿Ĺ1Ԥʤ)Ȼפʤ0ʳ
    encodedȻפʤ1֤VOS3ǤASCIIѤ */
char	*p;
{
	char	*q, *r;
	int	l;

	for(q = p; 0x20 <= *q && *q <= 0x60; q++);
	if(!b64_mode){
		if(!iseol(*q) || (l = *p - 0x20) > ENCSIZ) return -1;
#ifndef VOS3 /* VOS3ǤϹڤȸȽǤξ礬 */
		if((l + 2) / 3 * 4 + 1 != q - p) return -1;
#endif
		return l == ENCSIZ;
	} else {
		for(r = q; *r == B64EQConverted; r++);
		if(!iseol(*r) || r - q > 2 || (r - p) % 4 || r == p) return -1;
		return r == q && r - p >= ENCSIZ * 4 / 3;
	}
}

static	int	isencendline(s) /* /^[ `]?[ `]?$/ ɤ */
char	*s;
{
	char	*p;

	for(p = s; *p == 0x20 || *p == 0x60; p++);
	return p - s <= 2 && iseol(*p);
}
#define isb64endline(s) strconsthead("====", (s))
#define isuuendline(s) strconsthead("end", (s)) /* äȤ뤤 */
#define isendline(s) (b64_mode ? isb64endline(s) : isuuendline(s))
static	void	noend()
{
	cmd_errout("No end line\n");
	exit(ERRLVL);
}

static	void	decode(inf, otf)
FILE	*inf, *otf;
 /* otfNULLξ硢ϤϤʤʳ̾Ʊư */
{
	char	buf[2][LBUFSIZ], *p, *q;
	int	sw = 0;

	for(;;){
		p = fgets(buf[sw], LBUFSIZ, inf); /* ιԤVOS3 CWarning
		 ФΤVOS3 CΥХǡˤɬפʤ */
		if(NULL == p) noend();
		if(b64_mode && isb64endline(p)) break;
		predecode(p);
		 /* VOS3ξǤ⤳ASCIIˤʤ
		    ʸӤ'A'Τ褦ʸɽѤʤ */

		if(ign_garbage){
		retry_this_line:
			switch(gbgchk(p)){
			case -1:
				continue;
			case 1:
				break;
			default:
			 /* ûԤξ硢߰ʳμιԤ/^[ `]?[ `]?$/
			    ³ end Ǥ˸¤ꤳιԤʪȽ
			    âbase64ξϼ ==== ɤȽ */

				if(!b64_mode){
					for(;;){
						q= fgets(buf[!sw],LBUFSIZ,inf);
						if(NULL == q) noend();

						predecode(q);
						if(isencendline(q)) break;
						 /* /^[ `]?[ `]?$/ Ĥ */

						if(gbgchk(q) >= 0){
						 /* qʪβǽ */
							p = q, sw = !sw;
							goto retry_this_line;
						}
					}
				}

				for(;;){ /* ͭʹԤendõ */
					q = fgets(buf[!sw], LBUFSIZ, inf);
					if(NULL == q) noend();

					 /* endɤȽǤpredecode()
					    ˤ뤳 */
					if(isendline(q)) break;
					 /* endĤäpʪ */

					predecode(q);
					if(gbgchk(q) >= 0){
					 /* qʪβǽ */
						p = q, sw = !sw;
						goto retry_this_line;
					}
				}

				 /* pʪξ礳ιԤϺǸencoded */
				b64_mode ? bdecodeline(p, otf) :
					(void)decodeline(p, otf);
				return; /* endȯ */
			}
			 /* pϺǸǤϤʤencoded */
			b64_mode ? bdecodeline(p, otf) :
				(void)decodeline(p, otf);
		} else {
			if(b64_mode){
				bdecodeline(p, otf);
			} else {
				if(!decodeline(p, otf)){
					if(NULL == fgets(buf[sw], LBUFSIZ, inf)
					   || !isendline(buf[sw])) noend();
					return;
				}
			}
		}
	}
}
